package com.autentia.tutoriales.spring.biblioteca.cliente.test;

import org.junit.Assert;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.FileSystemXmlApplicationContext;

import com.autentia.tutoriales.spring.ws.biblioteca.cliente.BibliotecaCliente;
import com.autentia.tutoriales.spring.ws.biblioteca.cliente.Libro;

/**
 * Tests de verificación del servicio web de consulta de libros
 * @author Carlos García. Autentia
 * @see http://www.mobiletest.es
 */
public class BibliotecaTest  {
	private ApplicationContext	factory;
	
	/**
	 * Inicializamos el contexto de Spring
	 */
	@org.junit.Before
	public void initTests(){
		this.factory  = new FileSystemXmlApplicationContext("classpath:applicationContext.xml");
	}
	
	/**
	 * En verdad esto no es un test, simplemente lo pongo aqui por comodidad y no 
	 * tener que crearme un proyecto independenciente con una aplicación que realize lo mismo 
	 * que puedo hacer con este "test".
	 */
    @org.junit.Test
    public void test1(){
    	BibliotecaCliente		stub	= (BibliotecaCliente) factory.getBean("biblioStub");
		java.util.List<Libro>	libros	=  stub.getLibros(".net", "avanzado");
		if (libros != null){
			 for (int i = 0, lcount = libros.size(); i < lcount; i++){
				 Libro libro = libros.get(i);
				 System.out.println(libro.getEditorial() + " " + libro.getTitulo() + " "  +  libro.getPaginas() + " " +  libro.getPrecio());		 
			 }
		} else {
			System.out.println("No hay libros");
		}
		
    	Assert.assertTrue(true);
    }
}
